<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>

  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <section class="content-header">
        <div class="container">
          <div class="row mb-2">
                <div class="col-sm-12 text-center">
                    <h1>CRUD Chapter</h1>
                </div>
    
                <div class="mb-3 mt-5">
                    <button class="btn btn-success" id="btn-create-chapter">Thêm Mới Chapter</button>
                </div>
    
            </div>
            <table class="table table-bordered table-striped table-hover text-center bg-light" id="chapter-table">
                <thead>
                  <tr>
                    <th>STT</th>
                    <th>Tên Bài</th>
                    <th>Mã bài</th>
                    <th>Giới Thiệu</th>
                    <th>Trang</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
        
                </tbody>
            </table>
        </div>
        <!-- /.container-fluid -->

  
        <!-- create chapter -->
        <div class="modal" id="modal-create-chapter" tabindex="-1" role="dialog">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title">Tạo Mới Chapter </h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                    <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Id Book</label>
                      </div>
                      <div class="col-8">
                        <select type="text" id="select-id-chapter-create" class="form-control">
                            <option value="0">Chọn</option>
                        </select>
                      </div>
                    </div>
                  </div>
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Tên Bài</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-ten-chapter-create" class="form-control">
                      </div>
                    </div>
                  </div>
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Mã Bài</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-ma-chapter-create" class="form-control">
                      </div>
                    </div>
                  </div>
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Giới Thiệu</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-gioi-thieu-chapter-create" class="form-control">
                      </div>
                    </div>
                  </div>
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Trang</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-trang-chapter-create" class="form-control">
                      </div>
                    </div>
                  </div>
                </div>

                <div class="modal-footer">
                  <button type="button" class="btn btn-success confirm-create-chapter">Confirm</button>
                  <button type="button" class="btn btn-danger cancel-create-chapter" data-dismiss="modal">Cancel</button>
                </div>
              </div>
            </div>
          </div>

          <!-- update chapter -->
          <div class="modal" id="modal-update-chapter" tabindex="-1" role="dialog">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title">Update Chapter </h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Tên Bài</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-ten-chapter-update" class="form-control">
                      </div>
                    </div>
                  </div>
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Mã Bài</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-ma-chapter-update" class="form-control">
                      </div>
                    </div>
                  </div>
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Giới Thiệu</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-gioi-thieu-chapter-update" class="form-control">
                      </div>
                    </div>
                  </div>
                  <div class="col-12">
                    <div class="row">
                      <div class="col-4">
                        <label for="" class="font-weight-bold">Trang</label>
                      </div>
                      <div class="col-8">
                        <input type="text" id="inp-trang-chapter-update" class="form-control">
                      </div>
                    </div>
                  </div>
                </div>

                <div class="modal-footer">
                  <button type="button" class="btn btn-success confirm-update-chapter">Confirm</button>
                  <button type="button" class="btn btn-danger cancel-update-chapter" data-dismiss="modal">Cancel</button>
                </div>
              </div>
            </div>
          </div>

          <!-- delete chapter -->

          <div class="modal" tabindex="-1" role="dialog" id="modal-delete-chapter">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title">Delete Chapter</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <p>Chắc chắn xóa chứ</p>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-danger" id="btn-delete-chapter">Comfirm</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>


    </section>



</body>

<script>
$(document).ready(function () {
//định nghĩa table chapter
const gCOLS_ID = 0;
    const gCOLS_TEN_BAI = 1;
    const gCOLS_MA_BAI = 2;
    const gCOLS_GIOI_THIEU = 3;
    const gCOLS_TRANG = 4;
    const gCOL_ACTION1 = 5;

    var STT2 = 1;
    var gIdChapter = 0;

    const gORDER_COL = ["id", "tenBai","maBai", "gioiThieu", "trang"];
    var vTableData = $("#chapter-table").DataTable({
      columns: [
        { data: gORDER_COL[gCOLS_ID] },
        { data: gORDER_COL[gCOLS_TEN_BAI] },
        { data: gORDER_COL[gCOLS_MA_BAI] },
        { data: gORDER_COL[gCOLS_GIOI_THIEU] },
        { data: gORDER_COL[gCOLS_TRANG] },
        { data: gORDER_COL[gCOL_ACTION1] },
      ],
      columnDefs: [
        {
          targets: gCOLS_ID,
          render: function () {
            return STT2++;
          }
        },
        {
          "targets": gCOL_ACTION1,
          "defaultContent": `<i class="far fa-edit edit-chapter" style= "color : green ; cursor: pointer;" title="Edit " ></i>  
                            <i class="fas fa-trash-alt delete-chapter" style= "color : red ; cursor: pointer;" title="Delete"></i>`
        }
      ],
      searching: false,
    });

    onPageLoading();


    function onPageLoading() {
      "use strict";
      callApiGetAllChapterShowOnTable();
      loadIdToSelectIdBook();
    }

    function loadIdToSelectIdBook(){
        "use strict";
        $.ajax({
        url: "http://localhost:8080/book/all",
        type: "GET",

        dataType: "json",
        success: function (res) {
            loadDataIntoSelectIdBook(res);
        },
        error: function (err) {
          console.log(err.responseText);
        }
      })
    }
    function loadDataIntoSelectIdBook(paramObject) {
        for (var bI = 0; bI < paramObject.length; bI++) {
            $('#select-id-chapter-create').append($('<option>', {
                value: paramObject[bI].id,
                text: paramObject[bI].tenChuong + " || id là :" + paramObject[bI].id,
            }));
        }

    }

    //Hàm gọi APi lấy ra toàn bộ chapter
    function callApiGetAllChapterShowOnTable() {
      "use strict";
      $.ajax({
        url: "http://localhost:8080/chapter/all",
        type: "GET",

        dataType: "json",
        success: function (res) {
          console.log(res);
          vTableData.clear();
          vTableData.rows.add(res);
          vTableData.draw();
        },
        error: function (err) {
          console.log(err.responseText);
        }
      })
    }


    // gán sự kiện cho nút add chapter
    $("#btn-create-chapter").on("click", function () {
        $("#modal-create-chapter").modal("show");
        $("#select-id-chapter-create").val("0");
        
    });

    // confirm chapter create
    $(".confirm-create-chapter").on("click", function () {
        onBtnCreateChapterClick();
    });

    function onBtnCreateChapterClick() {
        var vId = $("#select-id-chapter-create").val();
        if(vId == "0"){
            alert("Chưa chọn id")
        }else{
            var vObj = {
                tenBai: $("#inp-ten-chapter-create").val().trim(),
                maBai: $("#inp-ma-chapter-create").val().trim(),
                gioiThieu: $("#inp-gioi-thieu-chapter-create").val().trim(),
                trang: $("#inp-trang-chapter-create").val().trim(),
            };
        

        console.log(vObj);
        var vCheck = validateChapterData(vObj);
        if (vCheck) {

        $.ajax({
                url: "http://localhost:8080/chapter/create/" + vId,
                type: "POST",
                contentType: "application/json; charset=UTF-8",
                data: JSON.stringify(vObj),
                success: function (res) {
                console.log(res);
                alert("Tạo mới chapter thành công");
                window.location.reload();
                },
                error: function (err) {
                console.log(err.responseText);
                }
            })
        }
        }
       
    }
    //Hàm validate create chapter
    function validateChapterData(paramObj) {
        "use strict"
    
        if (paramObj.tenBai === "") {
        alert("Hãy nhập tên bài");
        return false;
        } else if (paramObj.maBai === "") {
        alert("Hãy nhập mã bài");
        return false;
        } else if (paramObj.gioiThieu === "") {
        alert("Hãy nhập giới thiệu");
        return false;
        }  else if (paramObj.trang === "") {
        alert("Hãy nhập trang");
        return false;
        }   
        
        return true;
    }

     //Gán event handler khi click vào hàng bất kỳ trong table image
    $("#chapter-table").on("click", "td", function () {
      onBtnChapterTableRowClick(this);
    });
    // gán sự kiện cho nút update chapter
    $(document).on("click", ".edit-chapter", function () {
      $("#modal-update-chapter").modal("show");
      onBtnChapterTableRowClick(this);
    });

    // confirm update chapter
    $(".confirm-update-chapter").on("click", function () {
      onBtnUpdateChapterClick();
    });

    // cancel update chapter
    $(".confirm-update-chapter").on("click", function () {
      $("#modal-update-chapter").modal("hide");
    });



    // gán sự kiện cho nút delete chapter
    $(document).on("click",".delete-chapter",function() {
      $("#modal-delete-chapter").modal("show");
    }); 

    // xác nhận xóa chapter
    $("#btn-delete-chapter").on("click", function () {
        onBtnDeleteChapterClick();
    })

    //Hàm thực thi khi click vào hàng bất kỳ
    function onBtnChapterTableRowClick(paramTableCell) {
        var vClickedRow = $(paramTableCell).parents("tr");
        var vRowData = vTableData.row(vClickedRow).data();
        gIdChapter = vRowData.id;
        console.log("Đã click vào row có id là: " + gIdChapter);
        callAjaxApiGetChapterById(gIdChapter);
    }

        //Hàm gọi API để lấy dữ liệu chapter theo id
        function callAjaxApiGetChapterById(paramId) {
            $.ajax({
                url: "http://localhost:8080/chapter/detail/" + paramId,
                type: "GET",
                dataType: "json",
                success: function (res) {
                console.log(res);
                loadChapterDataToForm(res);
                },
                error: function (err) {
                console.log(err.responseText);
                }
            })
        }

            //Hàm load dữ liệu chapter lên form
        function loadChapterDataToForm(paramRes) {
            $("#inp-ten-chapter-update").val(paramRes.tenBai);
            $("#inp-ma-chapter-update").val(paramRes.maBai);
            $("#inp-gioi-thieu-chapter-update").val(paramRes.gioiThieu);
            $("#inp-trang-chapter-update").val(paramRes.trang);
        }

         //Hàm thực thi khi nhấn nút Update chapter
        function onBtnUpdateChapterClick() {
        "use strict";
        if (gIdChapter == 0) {
            alert("Hãy click chọn hàng cần update");
        }
        else {
            var vObj = {
            tenBai: $("#inp-ten-chapter-update").val(),
            maBai: $("#inp-ma-chapter-update").val(),
            gioiThieu: $("#inp-gioi-thieu-chapter-update").val(),
            trang: $("#inp-trang-chapter-update").val(),
            };

            var vCheck = validateChapterData1(vObj);
            if (vCheck) {
            $.ajax({
                url: "http://localhost:8080/chapter/update/" + gIdChapter,
                type: "PUT",
                contentType: "application/json; charset=UTF-8",
                async: false,
                data: JSON.stringify(vObj),
                success: function (res) {
                console.log(res);
                alert("Update chapter thành công");
                window.location.reload();
                },
                error: function (err) {
                console.log(err.responseText);
                }
            });
            };
        }
        }

        //Hàm validate update chapter
        function validateChapterData1(paramObj) {
            "use strict"
            if (paramObj.tenBai === "") {
                alert("Hãy nhập tên bài");
                return false;
            } else if (paramObj.maBai === "") {
                alert("Hãy nhập mã bài");
                return false;
            } else if (paramObj.gioiThieu === "") {
                alert("Hãy nhập giới thiệu");
                return false;
            }  else if (paramObj.trang === "") {
                alert("Hãy nhập trang");
                return false;
            }
            return true;
        }

            //Hàm thực thi khi click vào hàng bất kỳ
        function onBtnChapterTableRowClick(paramTableCell) {
            var vClickedRow = $(paramTableCell).parents("tr");
            var vRowData = vTableData.row(vClickedRow).data();
            gIdChapter = vRowData.id;
            console.log("Đã click vào row có id là: " + gIdChapter);
            callAjaxApiGetChapterById(gIdChapter);
        }

        //Hàm thực thi khi nhấn nút Delete Chapter
        function onBtnDeleteChapterClick() {
            "use strict";
            if (gIdChapter == 0) {
                alert("Hãy click chọn hàng cần delete");
            }
            else if (confirm("Bạn có muốn xóa chapter có id : " + gIdChapter + " ?") == true) {
                $.ajax({
                url: "http://localhost:8080/chapter/delete/" + gIdChapter,
                type: "DELETE",
                dataType: "json",
                success: function (res) {
                    console.log(res);
                    alert("Delete chapter thành công");
                    window.location.reload();
                },
                error: function (err) {
                    console.log(err.response);
                }
                });
        }
        }
})
    




</script>